#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
ll a[30005];
ll b[30005];
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t;
    cin>>t;
    while(t--){
        int n;
        cin>>n;
        for(int i=1;i<=n;i++){
            cin>>a[i];
        }
        for(int i=1;i<=n;i++){
            cin>>b[i];
        }
        int l=0;
        int r=0;
        int x=0;
        int y=0;
        for(int i=1;i<=n;i++){
            if(a[i]!=0){
                l=i;
                x=a[i];
            }
            if(b[i]!=0){
                r=i;
                y=b[i];
            }
        }
        if((abs(l-r)%2==0&&x!=y)||((abs)(l-r)%2!=0&&x==y)){
            cout<<"NE"<<endl;
        }
        else{
            cout<<"DA"<<endl;
        }
    }
    return 0;
}